/*
 *	fram.c
 *
 *	ARCADIA/EMU
 *
 *	* Sun May 01 22:12:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

/* %r10 s2650_read(%r12); */
asm("
	.code
	.align	1
	.global	s2650_read
s2650_read:
	xcmp	%r12, 0x1800		; $0000-$0FFF: ROM, $1000-$17FF: 
	xjrlt	_s2650_read_mem
	xcmp	%r12, 0x1c00		; $1800-$1BFF: UVIARAMAI/O
	xjrlt	_s2650_read_uvi
	; /** FALLTHRU **/		; $1C00-$1FFF: , $2000-$7FFF: ROM
_s2650_read_mem:
	ext	mem@ah
	ext	mem@al
	ld.ub	%r10, [%r12]		; return mem[addr]
	ret
_s2650_read_uvi:
	xcall	s2650_leave		; sReLXg𔲂܂B
	xand	%r12, %r12, 0x3ff	; return uvi_read(addr & 0x3ff)
	xcall	uvi_read
	xjp	s2650_enter		; sReLXgɓ܂B
");

/* void s2650_write(%r12, %r13); */
asm("
	.code
	.align	1
	.global	s2650_write
s2650_write:
	xcmp	%r12, 0x1800		; $0000-$0FFF: ROM, $1000-$17FF: 
	xjrlt	_s2650_write_rom
	xcmp	%r12, 0x1c00		; $1800-$1BFF: UVIARAMAI/O
	xjrlt	_s2650_write_uvi
	; /** FALLTHRU **/		; $1C00-$1FFF: , $2000-$7FFF: ROM
_s2650_write_rom:
	ret				; ** no job **
_s2650_write_uvi:
	xcall	s2650_leave		; sReLXg𔲂܂B
	xand	%r12, %r12, 0x3ff	; uvi_write(addr & 0x3ff, data)
	xcall	uvi_write
	xjp	s2650_enter		; sReLXgɓ܂B
");

/****************************************************************************
 *	
 ****************************************************************************/
